import engine
from vector import *
import pygame

class Actor:
    def __init__(self,engine,**kw):
        self.bounds=pygame.Rect(-5,-5,10,10)
        
        self.groups=[] #do not touch.
        self.image=None
        self.tick=0
        self.engine=engine
        self.position=(320,240)
        self.drawPosition=self.position
        self.health=100
        self.damage=10
        self.enemy=False
        self.screenbounds=self.bounds.move(self.position)
        #origin defaults to top,left
        self.__dict__.update(kw)
        
    def think(self):
        self.screenbounds=self.bounds.move(self.position)
        self.tick+=1
        
    def draw(self,surface):
        self.drawPosition=subv(self.position,self.engine.scrollPosition)
        try:
            img,offset=self.image
            surface.blit(img,subv(self.drawPosition,offset))
            
        except:
            self.drawBounds(surface)
        if self.engine.debug:
            surface.set_at(self.drawPosition,(255,0,0,255))
            self.drawBounds(surface)
    def drawBounds(self,surface):
        pygame.draw.rect(surface,(0,0,255),self.screenbounds.move(mulv(self.engine.scrollPosition,-1)),1)
            
    def kill(self):
        for g in self.groups:
            g.remove(self)
        self.isAlive=False
        
    def onCollide(self,other):
        # 'collision\n'
        pass

    def isOffScreen(self):
        x,y=self.position
        if x>engine.screenWidth or x<0: return True
        elif y>engine.screenHeight or y<0: return True
        else: return False
        
