import pygame
from vector import *
import math

def screenToMap(scrpos,scrollpos):
    return subv(scrpos,scrollpos)

def mapToScreen(mpos,scrollpos):
    return addv(scrpos,scrollpos)

class Map:
    """the map object! maps are zero indexed from the bottom left corner"""
    def __init__(self,mapImage,overlayImage,blockSize,tileMap=None):
        emptyTile=pygame.Surface((blockSize,blockSize))
        emptyTile.fill((255,255,255))
        self.tileVec=[emptyTile]*255
        for tidx in tileMap:
            tile=pygame.image.load(tileMap[tidx]).convert()
            self.tileVec[tidx]=tile
            
        self.blockSize=blockSize
        levelMapSurface=pygame.image.load(mapImage)
        self.img=levelMapSurface
        self.mapWidth=levelMapSurface.get_width()
        self.mapHeight=levelMapSurface.get_height()
        self.scaledMap=pygame.transform.scale(levelMapSurface,(self.mapWidth*blockSize,self.mapHeight*blockSize))
        tempMap=list(pygame.image.tostring(levelMapSurface,'P',0))
        self.map=[ord(c) for c in tempMap]

    def getBlock(self,pos):
        """ it is assumed that 255 is the level boundary block type
        queries off of the edge of the map return this"""
        (x,y)=pos
        x/=self.blockSize
        y/=self.blockSize
        x=int(x)
        y=int(y)
        if not (x>=0 and x<self.mapWidth and y>=0 and y<self.mapHeight):
            return 0
        return self.map[x+(y)*self.mapWidth]
    def moveXToBlockEdge(self,position):
        (x,y)=position
        x/=self.blockSize
        y/=self.blockSize
        return (round(x)*self.blockSize,position[1])
    def moveYToBlockEdge(self,position):
        (x,y)=position
        x/=self.blockSize
        y/=self.blockSize
        return (position[0],round(y)*self.blockSize)

    def drawMap(self,surf,scrollCenter):
        #x,y=scrollCenter
        scx,scy=scrollCenter
        #surf.blit(self.scaledMap,(-x,-y))
        mcorner=screenToMap((-self.blockSize,-self.blockSize),scrollCenter)# the starting point of the map
        mx,my=mcorner
        mcorner=(math.floor(mx),math.floor(my))
        lenx=surf.get_width()/self.blockSize +2
        leny=surf.get_height()/self.blockSize +2
        xoffs=-(scx%self.blockSize)-self.blockSize
        yoffs=-(scy%self.blockSize)-self.blockSize
        xp,yp=(xoffs,yoffs)
        for x in xrange(lenx):
            yp=yoffs
            for y in xrange(leny):
                
                bloc=self.getBlock(subv((xp-self.blockSize,yp-self.blockSize),mcorner))
                if bloc:
                    surf.blit(self.tileVec[bloc],(xp,yp))
                yp+=self.blockSize
                #yi+=1
            xp+=self.blockSize
            #xi+=1
        
        
    
